> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List all Migration Sources



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/storage-data.yml get /storage/migration_sources
openapi: 3.1.0
info:
  title: Telnyx Storage & Data API
  version: 2.0.0
  description: API for Storage & Data.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /storage/migration_sources:
    get:
      tags:
        - Data Migration
      summary: List all Migration Sources
      operationId: ListMigrationSources
      parameters: []
      responses:
        '200':
          description: List Migration Sources Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    items:
                      $ref: '#/components/schemas/MigrationSourceParams'
                  meta:
                    $ref: '#/components/schemas/PaginationMetaSimple'
          headers: {}
        '401':
          description: Unauthorized
        '422':
          description: Unprocessable Entity
      deprecated: false
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            const migrationSources = await
            client.storage.migrationSources.list();


            console.log(migrationSources.data);
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            migration_sources = client.storage.migration_sources.list()
            print(migration_sources.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tmigrationSources, err := client.Storage.MigrationSources.List(context.TODO())\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", migrationSources.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.storage.migrationsources.MigrationSourceListParams;

            import
            com.telnyx.sdk.models.storage.migrationsources.MigrationSourceListResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    MigrationSourceListResponse migrationSources = client.storage().migrationSources().list();
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            migration_sources = telnyx.storage.migration_sources.list

            puts(migration_sources)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $migrationSources = $client->storage->migrationSources->list();

              var_dump($migrationSources);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx storage:migration-sources list \
              --api-key 'My API Key'
components:
  schemas:
    MigrationSourceParams:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the data migration source.
          readOnly: true
        provider:
          type: string
          enum:
            - aws
            - telnyx
          description: >-
            Cloud provider from which to migrate data. Use 'telnyx' if you want
            to migrate data from one Telnyx bucket to another.
        source_region:
          type: string
          description: >-
            For intra-Telnyx buckets migration, specify the source bucket region
            in this field.
        provider_auth:
          type: object
          properties:
            access_key:
              type: string
              description: >-
                AWS Access Key. For Telnyx-to-Telnyx migrations, use your Telnyx
                API key here.
            secret_access_key:
              type: string
              description: >-
                AWS Secret Access Key. For Telnyx-to-Telnyx migrations, use your
                Telnyx API key here as well.
        bucket_name:
          type: string
          description: Bucket name to migrate the data from.
      required:
        - provider
        - provider_auth
        - bucket_name
    PaginationMetaSimple:
      type: object
      properties:
        page_number:
          type: integer
          example: 2
        page_size:
          type: integer
          example: 25
        total_pages:
          type: integer
          example: 3
        total_results:
          type: integer
          example: 55
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````